' HC2_DP_RX1D.bas for SN 101545
' 2022/10/09 [2779 bytes]
' uses: ^, A, B, I, K, N

I2cD[31]=$3C
Gosub _InitOled
Gosub _ContrastMax
Gosub _SetMyChars

Do
	Recv 2000
	Lclr
	Gosub _ClearOled
	If Stat = 10 Then
		Lprint Rxd
		Lpos = 64: Lprint "rssi"; Rssi
		If Rxd[7] > 10 Then
			i = 0: n = 0: ^ = "": A = $20: B = $20
			For i = 0 To Rxd[7] - 1
				If Rxd[i + 8] = $3A Then
					n = n + 1
					If n = 1 Then
						^ = ^; Chr($F2); "C ": Gosub _DrawText
					ElseIf n = 2 Then
						^ = ^; "% ": Gosub _DrawText
					ElseIf n = 3 Then
						^ = ^; Chr($F2);"CDP ": Gosub _DrawText2
					ElseIf n = 4 Then
						I2cD(0) = ^[0]: Gosub _WriteData
					EndIf
					^ = ""
				Else
					^ = ^; Chr(Rxd[i + 8])
				EndIf
			Next
			I2cD(0) = ^[0]: Gosub _WriteData
		Else
			^ = "HC2": Gosub _DrawText1
			^ = "no response": Gosub _DrawText2
		EndIf
		^ = Rssi
		I2cD[1] = 12: I2cD[2] = 1: Gosub _SetCur: Gosub _DrawText
		
		I2cD[1] = 13: I2cD[2] = 0: Gosub _SetCur
		If Rssi < -130 Then I2cD[1] = 0
		Else I2cD[1] = 9 - Abs(Rssi) / 15
		EndIf
		Gosub _DrawAntLevel		
	Else
		Lpos = 64: Lprint "error "; Stat
		I2cD[1] = 14: I2cD[2] = 0: Gosub _SetCur
		I2cD[1] = 0: Gosub _DrawAntLevel
	EndIf
	Send "OK"
	Delay 500
Loop
End

'' J[\ʒu
_SetCur
	'' I2cD[1]=Col,I2cD[2]=Row [0 base]
	I2cD[0] = $80 + I2cD[2] * $20  + I2cD[1]
	Gosub _WriteCommand
Return

_DrawText
	For k = 0 To ^[]-1 
		I2cD[0] = ^[k]: Gosub _WriteData
	Next
Return

_DrawText1
	I2cD[0] = $80: Gosub _WriteCommand
	For k = 0 To ^[] - 1 
		I2cD[0] = ^[k]: Gosub _WriteData
	Next	
Return

_DrawText2
	I2cD[0] = $80 + $20: Gosub _WriteCommand
	For k = 0 To ^[] - 1 
		I2cD[0] = ^[k]: Gosub _WriteData
	Next	
Return

_ClearOled
	I2cD[0] = $01: Gosub _WriteCommand
Return

_WriteCommand
	I2cW I2cD[31],$00,1: Delay 10
Return

_WriteData
	I2cW I2cD[31],$40, 1: Delay 1
Return

_InitOled
	'' Clear Display
	I2cD[0] = $01: Gosub _WriteCommand
	'' Return Home
	I2cD[0] = $02: Gosub _WriteCommand
	'' Display ON + Cursor ON + Blink ON [8+4+2+1=16=$0F]
	'I2cD[0] = $0F
	'' Display ON + Cursor OFF + Blink OFF [8+4+0+0=12=$0C]
	I2cD[0] = $0C: Gosub _WriteCommand
	'' Clear Display
	I2cD[0] = $01: Gosub _WriteCommand
Return

_ContrastMax
	I2cD[0] = $2A: Gosub _WriteCommand ''RE=1
	I2cD[0] = $79: Gosub _WriteCommand ''SD=1
	I2cD[0] = $81: Gosub _WriteCommand ''RgXgZbg
	I2cD[0] = $FF: Gosub _WriteCommand ''Pxl`w ''W=$7F
	I2cD[0] = $78: Gosub _WriteCommand ''SD Oɂǂ
	I2cD[0] = $28: Gosub _WriteCommand ''2C=@28=m[} 
Return

_DrawAntLevel
	If I2cD[1] = 0 Then: I2cD[0] = 0: Gosub _WriteData
	ElseIf I2cD[1] =  1 Then I2cD[0] = 1: Gosub _WriteData
	Elseif I2cD[1] >= 2 Then I2cD[0] = 2: Gosub _WriteData
		If I2cD[1] =  3 Then I2cD[0] = 3: Gosub _WriteData
		ElseIf I2cD[1] >= 4 Then I2cD[0] = 4: Gosub _WriteData
			If I2cD[1] >= 5 Then I2cD[0] = 5: Gosub _WriteData
			EndIf
		EndIf
	EndIf
Return

'' Oo^
_SetMyChars
	I2cD[0] = $40 | 0 * $08: Gosub _WriteCommand
	I2cD[0] = $1C '11100
	I2cD[1] = $08 '01000
	I2cD[2] = $08 '01000
	I2cD[3] = $00 '00000
	I2cD[4] = $00 '00000
	I2cD[5] = $00 '00000
	I2cD[6] = $00 '00000
	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 1 * $08: Gosub _WriteCommand
	I2cD[0] = $1C '11100
	I2cD[1] = $08 '01000
	I2cD[2] = $08 '01000
	I2cD[3] = $00 '00000
	I2cD[4] = $00 '00000
	I2cD[5] = $0C '01100
	I2cD[6] = $0C '01100
'	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 2 * $08: Gosub _WriteCommand
	I2cD[0] = $1C '11100
	I2cD[1] = $08 '01000
	I2cD[2] = $08 '01000
	I2cD[3] = $00 '00000
	I2cD[4] = $03 '00011
	I2cD[5] = $1B '11011
	I2cD[6] = $1B '11011
'	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 3 * $08: Gosub _WriteCommand
	I2cD[0] = $00 '00000
	I2cD[1] = $00 '00000
	I2cD[2] = $00 '00000
	I2cD[3] = $18 '11000
	I2cD[4] = $18 '11000
	I2cD[5] = $18 '11000
	I2cD[6] = $18 '11000
'	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 4 * $08: Gosub _WriteCommand
	I2cD[0] = $00 '00000
	I2cD[1] = $00 '00000
	I2cD[2] = $03 '00011
	I2cD[3] = $1B '11011
	I2cD[4] = $1B '11011
	I2cD[5] = $1B '11011
	I2cD[6] = $1B '11011
'	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1

	I2cD[0] = $40 | 5 * $08: Gosub _WriteCommand
	I2cD[0] = $00 '00000
	I2cD[1] = $18 '11000
	I2cD[2] = $18 '11000
	I2cD[3] = $18 '11000
	I2cD[4] = $18 '11000
	I2cD[5] = $18 '11000
	I2cD[6] = $18 '11000
'	I2cD[7] = $00 '00000
	I2cW I2cD[31],$40, 8: Delay 1
Return
